/*
 * generated by Xtext 2.35.0
 */
package swt.most.statemachine.xtext.validation;

import org.eclipse.xtext.validation.Check;
import org.eclipse.xtext.validation.CheckType;

import swt.most.statemachine.FinalState;
import swt.most.statemachine.InitialState;
import swt.most.statemachine.StatemachinePackage;
import swt.most.statemachine.Transition;

/**
 * This class contains custom validation rules. 
 *
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
public class ParserValidator extends AbstractParserValidator {
	
	/*
	 * Small example of the validations of other non structural semantics.
	 * It checks if the Transition to or from special states are correct, since these are not limited by the syntax (meta model).
	 */
	@Check(CheckType.FAST)
	public void checkTransitionWithInvolvedSpecialStates( Transition transition ) {
		if ( transition.getFrom() instanceof FinalState ) {
			error("A transition can not start from a final state", StatemachinePackage.Literals.TRANSITION__FROM);
		}
		if ( transition.getTo() instanceof InitialState ) {
			error("A transition can not end in an initial state", StatemachinePackage.Literals.TRANSITION__TO);
		}
	}
	
}
